<template>
    <v-container class="container pa-0" fluid>

        <div v-if="loading" class="text-center">
            <v-dialog v-model="dialog" width="250">
                <v-card>
                    <v-card-text class="pa-5 text-center">
                        Loading database...
                    </v-card-text>
                </v-card>
            </v-dialog>
        </div>
        <router-view></router-view>
        <NewUser
            :newUsers="userModel.newUsers"
            @addNewUser="userModel.addUser"
        />

        <v-bottom-navigation
            class="bottomNavigation"
            color="primary"
            :value="currentNavigation"
            dark
            shift
            horizontal
        >
            <v-btn v-for="navigationRoute in navigationRoutes" :key="navigationRoute.name"
                :style="{ height: '100%' }"
                :to="navigationRoute.name"
                :value="navigationRoute.name"
            >
                <span>{{ $t("calendar." + navigationRoute.name.replace('/', '')) }}</span>
                    <v-icon>{{ navigationRoute.icon }}</v-icon>
            </v-btn>
        </v-bottom-navigation>
    </v-container>
</template>

<script lang="ts">
import { Component, Inject, Provide, Vue } from 'vue-property-decorator'
import { Observer } from "mobx-vue"
import { RootStore } from "@/store"
import { CalendarModel } from "@/store/modules/calendar"
import { UserModel } from "@/store/modules/user"
import NewUser from "@/components/NewUser.vue"

@Observer
@Component({ components: { NewUser }})
export default class Landing extends Vue {
    @Inject("root") root !: RootStore
    @Inject("userModel") userModel !: UserModel
    @Provide("calendarModel") calendarModel = new CalendarModel(this.root)
    private navigationRoutes: Array<object> = [
        { name: "/calendar", icon: "mdi-calendar-month" },
        { name: "/chart", icon: "mdi-chart-arc" },
        { name: "/share", icon: "mdi-share-variant" },
        { name: "/chat", icon: "mdi-chat-outline" },
        { name: "/settings", icon: "mdi-tune" }
    ]
    private currentNavigation: string = "/calendar"
    private dialog: boolean = false

    get loading() {
        this.dialog = !this.root.ipfs.initialized;
        return !this.root.ipfs.initialized;
    }

    private mounted() {
        const currentRoute = this.$router.currentRoute;
        if (currentRoute !== undefined && currentRoute !== null) {
            // @ts-ignore
            this.currentNavigation = "/" + this.$router.currentRoute.name;
        }
    }
}

</script>

<style scoped>
.container {
    height: 100%;
    width: 100vw;
    background: rgb(60,78,108);
    background: repeating-linear-gradient(0deg, rgba(60,78,108,1) 0%, rgba(76,109,185,1) 48%, rgba(89,196,238,1) 100%);
}

.bottomNavigation {
    bottom: 0;
    position: fixed;
    z-index: 2;
}

.loadingDialog {
    height: 500px;
}
</style>
